//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PCookieServiceParent_h
#define PCookieServiceParent_h

#include "mozilla/net/PCookieService.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/ipc/BackgroundUtils.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class PCookieServiceParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::net::PNeckoParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::net::ChannelDiverterArgs ChannelDiverterArgs;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::ContentPrincipalInfoOriginNoSuffix ContentPrincipalInfoOriginNoSuffix;
    typedef mozilla::net::CookieStruct CookieStruct;
    typedef mozilla::net::CorsPreflightArgs CorsPreflightArgs;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::ExpandedPrincipalInfo ExpandedPrincipalInfo;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef mozilla::net::FTPChannelCreationArgs FTPChannelCreationArgs;
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::HeaderEntry HeaderEntry;
    typedef mozilla::ipc::HostObjectURIParams HostObjectURIParams;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef mozilla::net::HttpChannelCreationArgs HttpChannelCreationArgs;
    typedef mozilla::net::HttpChannelDiverterArgs HttpChannelDiverterArgs;
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::ipc::IPCBlobInputStreamParams IPCBlobInputStreamParams;
    typedef mozilla::ipc::IPCRemoteStream IPCRemoteStream;
    typedef mozilla::ipc::IPCRemoteStreamType IPCRemoteStreamType;
    typedef mozilla::ipc::IPCStream IPCStream;
    typedef mozilla::ipc::IconURIParams IconURIParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::InputStreamParamsWithFds InputStreamParamsWithFds;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::JSURIParams JSURIParams;
    typedef mozilla::net::LoadInfoArgs LoadInfoArgs;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::NullPrincipalURIParams NullPrincipalURIParams;
    typedef mozilla::net::OptionalCorsPreflightArgs OptionalCorsPreflightArgs;
    typedef mozilla::dom::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::net::OptionalHttpResponseHead OptionalHttpResponseHead;
    typedef mozilla::ipc::OptionalIPCStream OptionalIPCStream;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::net::OptionalLoadInfoArgs OptionalLoadInfoArgs;
    typedef mozilla::ipc::OptionalPrincipalInfo OptionalPrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::OriginAttributes OriginAttributes;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolFdMapping ProtocolFdMapping;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleNestedURIParams SimpleNestedURIParams;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::SlicedInputStreamParams SlicedInputStreamParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::net::nsHttpResponseHead nsHttpResponseHead;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::net::PNeckoChild PNeckoChild;

    typedef PCookieService::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvGetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const OriginAttributes& attrs,
            nsCString* result) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const nsCString& cookieString,
            const nsCString& serverTime,
            const OriginAttributes& attrs,
            const bool& aFromHttp) = 0;
    virtual mozilla::ipc::IPCResult
    RecvPrepareCookieList(
            const URIParams& host,
            const bool& isForeign,
            const OriginAttributes& attrs) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PCookieServiceParent();

    virtual ~PCookieServiceParent();

    PNeckoParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendTrackCookiesLoad(
            const nsTArray<CookieStruct>& cookiesList,
            const OriginAttributes& attrs);

    MOZ_MUST_USE bool
    SendRemoveCookie(
            const CookieStruct& cookie,
            const OriginAttributes& attrs);

    MOZ_MUST_USE bool
    SendRemoveBatchDeletedCookies(
            const nsTArray<CookieStruct>& cookiesList,
            const nsTArray<OriginAttributes>& attrsList);

    MOZ_MUST_USE bool
    SendRemoveAll();

    MOZ_MUST_USE bool
    SendAddCookie(
            const CookieStruct& cookie,
            const OriginAttributes& attrs);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace net
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::net::PCookieServiceParent*>
{
    typedef mozilla::net::PCookieServiceParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class CookieServiceParent :
    public PCookieServiceParent
{
    mozilla::ipc::IPCResult
    RecvGetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const OriginAttributes& attrs,
            nsCString* result) override;

    mozilla::ipc::IPCResult
    RecvSetCookieString(
            const URIParams& host,
            const bool& isForeign,
            const nsCString& cookieString,
            const nsCString& serverTime,
            const OriginAttributes& attrs,
            const bool& aFromHttp) override;

    mozilla::ipc::IPCResult
    RecvPrepareCookieList(
            const URIParams& host,
            const bool& isForeign,
            const OriginAttributes& attrs) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT CookieServiceParent();
    virtual ~CookieServiceParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
mozilla::ipc::IPCResult
CookieServiceParent::RecvGetCookieString(
        const URIParams& host,
        const bool& isForeign,
        const OriginAttributes& attrs,
        nsCString* result)
{
}

mozilla::ipc::IPCResult
CookieServiceParent::RecvSetCookieString(
        const URIParams& host,
        const bool& isForeign,
        const nsCString& cookieString,
        const nsCString& serverTime,
        const OriginAttributes& attrs,
        const bool& aFromHttp)
{
}

mozilla::ipc::IPCResult
CookieServiceParent::RecvPrepareCookieList(
        const URIParams& host,
        const bool& isForeign,
        const OriginAttributes& attrs)
{
}

void
CookieServiceParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT CookieServiceParent::CookieServiceParent()
{
    MOZ_COUNT_CTOR(CookieServiceParent);
}

MOZ_IMPLICIT CookieServiceParent::~CookieServiceParent()
{
    MOZ_COUNT_DTOR(CookieServiceParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PCookieServiceParent_h
